//Model T script
//Harey 2015
//This script is made to emulate as close as possible the controls of a Model T
//some things were omitted because of Racer limitations
//holding the clutch for first isn't necessary right now
//
//controls are as follows
//A - throttle up
//Z - throttle down
//gas pedal - brake pedal
//brake pedal - reverse pedal
//
//Known issue currently - you have to tap the reverse pedal to get the vehicle to shift from 2nd to 1st

rcar $car = get scriptowner car

shared int $modelt = 1
shared float $throtpos = 0.047
shared int $handbrake = 0

int $gear = get $car gear 
float $braking = 0
float $throttle = 0.047
int $keyPressed = 0


float $ratios[4] = float[4]{0.0,-4.0,2.75,1.00}


while 1 {
//handbrake for shifting from low to high
	if is key 32 pressed        //Toggle with key Spacebar
	{
	    if $keyPressed == 0
	    {
	        $keyPressed = 1 // mark that we pushed spacebar
		if $handbrake == 0
		{
			$handbrake = 1
		}
		else
		{
			$handbrake = 0
		}
	    }
	}
	else
	{
	    $keyPressed = 0            //Mark as released
	}
//reverse pedal, bunch of if statements
  //(get $car gear) == 2
  if is key 17 pressed        // toggle low gear by holding CTRL
  {
	set system "car0.gearbox.gear2_ratio" to $ratios[2]
	set $car gear 2
	$modelt = 1
  }
  else if (get $car brake) > 0
  {
	set $car brake 0
	set $car gear 1
	set system "car0.gearbox.gear1_ratio" to $ratios[1]
	$modelt = 0
  }
  else if $handbrake == 1          // if not low gear, then maybe high?
  {
	//if (get $car gear) == 3
	//set $car gear 3
	set $car gear 2
	set system "car0.gearbox.gear2_ratio" to $ratios[3]
	$modelt = 2
	
  }
  else
  {
		set $car gear 0
		$modelt = 3
  }
//changing throttle to brake
  if (get $car throttle) > 0
  {
	$braking = (get $car throttle)
	set $car brake $braking
	set $car throttle 0.047
  }
//setting throttle control on the keyboard
    if is key 65 pressed        //Toggle with key A
    {
	if $throttle < 1
	{
	$throttle = $throttle + 0.001
	$throtpos = $throtpos + 0.001
	}
	else if $throttle > 1
	{
		$throttle = 1
		$throtpos = 1
	}
    }
    else if is key 90 pressed //Toggle with key Z
    {
		if $throttle > 0.048
		{
		$throttle = $throttle - 0.001
		$throtpos = $throtpos - 0.001
		}
    }
	set $car throttle $throttle
	
  interrupt
}